// Services.cpp
//
// this file enumerates services started
//

#include "Main.h"

/*
typedef struct _ENUM_SERVICE_STATUS_PROCESS {  
LPTSTR lpServiceName;  
LPTSTR lpDisplayName;  
SERVICE_STATUS_PROCESS ServiceStatusProcess;
} ENUM_SERVICE_STATUS_PROCESS, *LPENUM_SERVICE_STATUS_PROCESS;

//*/
BYTE glBuffer[64 * 1024];
ENUM_SERVICE_STATUS_PROCESS *pService;

char gCurrentState[][24] = 
{
	"not valid",
	"STOPPED",
	"START_PENDING",
	"STOP_PENDING",
	"RUNNING",
	"CONTINUE_PENDING",
	"PAUSE_PENDING",
	"PAUSED"
};

// prints a service node to the screen for debugging
void printServiceNode(SERVICE_NODE *pSvc, DWORD number)
{
	DWORD i;

	for(i = 0; i < number; i++)
	{
		fprintf(stdout, "(%d) Display Name: %s\n  %s State:%u Type:%u PID:%u Flags:%u\n\n", 
			i, pSvc->disName, pSvc->svcName, pSvc->svcState, pSvc->svcType, pSvc->svcPid, pSvc->svcFlags);
		pSvc++;
	}
	return;
} // printServiceNode

// search for a name match, if displayName is true, check display name, otherwise 
// check service name, start is a hint as to what should be close to indx
int checkNameMatch(char *name, SERVICE_NODE *pSvc, int start, DWORD lenList, bool displayName)
{
	int cnt;

	if(displayName)
	{
		if( stricmp(name, (pSvc+start)->disName) == 0) return(start);
		return(-1);
	}

	// search starting from position in 2nd list, equal to position in first list
	// should often result in an immediate match
	for(cnt = start; cnt < (int) lenList; cnt++)
		if( stricmp(name, (pSvc+cnt)->svcName) == 0) return(cnt);

	// check first part of list, assumed before that it wsa equal/after first list
	// count backward from start
	for(cnt = start-1; cnt >= 0; cnt--)
		if( stricmp(name, (pSvc+cnt)->svcName) == 0) return(cnt);

	return(-1);	// not found
} // checkNameMatch

// check how well two service listings match
void matchServices(FILE *fptr, SERVICE_NODE *pSvc1, DWORD numOfSvc1, SERVICE_NODE *pSvc2, DWORD numOfSvc2, char *logFile1, char *logFile2)
{
	DWORD cnt, numberOfDiscrepancies;
	int result1, result2;

	numberOfDiscrepancies = 0;

	if(numOfSvc1 != numOfSvc2)
	{
		fprintf(fptr, "%3d) Number of Services in file1: %s (%u) \n\n --> different than \n\nNumber of Services in file2: %s (%u)\n\n\n", 
			++numberOfDiscrepancies, logFile1, numOfSvc1, logFile2, numOfSvc2);
	}
	else fprintf(fptr, "Number of Services match.\n\n\n");

	// go down the first list and set flag to true
	for(cnt = 0; cnt < numOfSvc1; cnt++)
	{
		// result is position found
		result1 = checkNameMatch( (pSvc1+cnt)->svcName, pSvc2, (int) cnt, numOfSvc2, false);
		if(result1 == -1)	// no match
		{
			fprintf(fptr, "%3d) ServiceName: \"%s\" not found in file2: %s\n\n", ++numberOfDiscrepancies, (pSvc1+cnt)->svcName, logFile2);
			continue;
		}

		// At this point, the service names match!
		(pSvc2+result1)->alreadyMatched = true;	// mark this service name as matched

		// found, check display name, only check this entry
		result2 = checkNameMatch( (pSvc1+cnt)->disName, (pSvc2), result1, 0, true);
		if(result2 == -1)	// display names did not match
		{
			fprintf(fptr, "\n%3d) For ServiceName: \"%s\"\n  -- Display name: \"%s\" in file1: %s\n\n  different from\n\n  -- Display Name: \"%s\" in file2: %s\n\n", ++numberOfDiscrepancies, 
				(pSvc1+cnt)->svcName, (pSvc1+cnt)->disName, logFile1, (pSvc2+result1)->disName, logFile2);
		}
		
		if( (pSvc1+cnt)->svcType != (pSvc2+result1)->svcType )
		{
			fprintf(fptr, "\n%3d) ServiceName: \"%s\"\n  -- Service Type = %u in file1: %s\n\n  different from\n\n  -- Service Type = %u in file2: %s\n\n", ++numberOfDiscrepancies, 
				(pSvc1+cnt)->svcName, (pSvc1+cnt)->svcType, logFile1, (pSvc2+result1)->svcType, logFile2);
		}

		if( (pSvc1+cnt)->svcState != (pSvc2+result1)->svcState )
		{
			char state1[32], state2[32];

			if( (pSvc1+cnt)->svcState < 8)
				strcpy(state1, gCurrentState[(pSvc1+cnt)->svcState]);
			else
				strcpy(state1, "Invalid state number");

			if( (pSvc2+result1)->svcState < 8)
				strcpy(state2, gCurrentState[(pSvc2+result1)->svcState]);
			else
				strcpy(state2, "Invalid state number");

			fprintf(fptr, "\n%3d) ServiceName: \"%s\"\n  -- Service State = %u <%s> in file1: %s\n\n  different from\n\n  -- Service State = %u <%s> in file2: %s\n\n", ++numberOfDiscrepancies, 
				(pSvc1+cnt)->svcName, (pSvc1+cnt)->svcState, state1, logFile1, (pSvc2+result1)->svcState, state2, logFile2);
			continue;
		}

		if( (pSvc1+cnt)->svcPid == 0 && (pSvc2+result1)->svcPid == 0 ) continue;	// service NOT running for both snapshots

		// if both are not zero, then in both snapshots the service was started
		if( (pSvc1+cnt)->svcPid != 0 && (pSvc2+result1)->svcPid != 0 )
		{
			if( (pSvc1+cnt)->svcFlags != (pSvc2+result1)->svcFlags )	// check the flags
			{
				fprintf(fptr, "\n%3d) ServiceName: \"%s\"\n  -- Service flags = %u in file1: %s\n\n  different from\n\n  -- Service Flags = %u in file2: %s\n\n\n", ++numberOfDiscrepancies, 
					(pSvc1+cnt)->svcName, (pSvc1+cnt)->svcFlags, logFile1, (pSvc2+result1)->svcFlags, logFile2);
			}
			continue;
		}

		// to get here, the two files have a discrepancy
		if( (pSvc1+cnt)->svcPid != 0 && (pSvc2+result1)->svcPid == 0 )	// service stopped in file 2
		{
			fprintf(fptr, "\n%3d) ServiceName: \"%s\" stopped in file2: %s\n\n", ++numberOfDiscrepancies, (pSvc1+cnt)->svcName, logFile2);
		}
		else // if( (pSvc1+cnt)->svcPid == 0 && (pSvc2+result1)->svcPid != 0 )  // service started in file 2
		{
			fprintf(fptr, "\n%3d) ServiceName: \"%s\" stopped in file1: %s\n\n", ++numberOfDiscrepancies, (pSvc1+cnt)->svcName, logFile1);
		}

	} // cnt loop

	// need to check for any services in file2 not in file 1
	for(cnt = 0; cnt < numOfSvc2; cnt++)
	{
		if( (pSvc2+cnt)->alreadyMatched == true ) continue;	// already matched
		if( (pSvc2+cnt)->svcName[0] == 0) continue;

		fprintf(fptr, "\n%3d) ServiceName: \"%s\" not found in file1: %s\n\n", ++numberOfDiscrepancies, (pSvc2+cnt)->svcName, logFile1);
	}
	fprintf(fptr, "\n\n * * * * *   Total Number of Service Discrepancies: %u   * * * * * \n\n", numberOfDiscrepancies);
	return;
} // matchServices

// read a services file
SERVICE_NODE *readServiceFile(FILE *fptr, DWORD &number)
{
	SERVICE_NODE *pTop, *pTmp;
	char buffer[512], *pc, delimiter[] = ": ";
	DWORD readCount;	// use this to prevent overflowing allocation

	number = 0;

	// get the number of services ahead of time
	while(1)
	{
		fgets(buffer, 512, fptr);
		if(feof(fptr))
		{
			fprintf(stderr, "\n\nError, did not find number of services.\n\n");
			exit(-1);
		}
		if(buffer[0] == 0x0a || buffer[0] == 0x0d) continue;
		break;
	} // end while

	pc = strtok(buffer, (char *) &delimiter);
	if(pc == NULL)
	{
		fprintf(stderr, "\n\nError reading file, NumServices not found.\n\n");
		exit(-1);
	}

	if(strcmp(pc, "NumServices") != 0)
	{
		fprintf(stderr, "\n\nError reading file, NumServices not present.\n\n");
		exit(-1);
	}

	pc = strtok(NULL, (char *) &delimiter);		// 2nd delimeter
	number = atol(pc);
	if(number == 0)
	{
		fprintf(stderr, "\n\nError, number of services is zero.\n\n");
		exit(-1);
	}

	printf("Number of Services = %u\n", number);

	pTop = (SERVICE_NODE *) malloc(number * sizeof(SERVICE_NODE) );
	if(pTop == NULL)
	{
		fprintf(stderr, "\n\nFatal Memory Error - Could not allocate %u bytes for service nodes.\n\n", number * sizeof(SERVICE_NODE));
		exit(-1);
	}

	pTmp = pTop;
	readCount = 0;
	while(1)
	{
		char tmpCh;
		int x;

		fgets(buffer, 512, fptr);	// get the display name, which is NOT the unique identifier
		if(feof(fptr)) break;
		if(buffer[0] == 0x0a || buffer[0] == 0x0d) continue;

		readCount++;
		if(readCount > number)	// have exceeded number in header
		{
			fprintf(stderr, "\n\nError - File has more services than specified in header (%u).\n\n", number);
			break;
		}

		// remove CR/LF charactger at the end
		x = (int) strlen(buffer) - 1;
		while(buffer[x] == 0x0a || buffer[x] == 0x0d)
		{
			buffer[x] = 0;
			x--;
		}

		pTmp->alreadyMatched = false;

		// save the display name
		strcpy(pTmp->disName, buffer);

		fgets(buffer, 512, fptr);	// get the service name (unique) and details
		if(feof(fptr)) break;
		if(buffer[0] == 0x0a || buffer[0] == 0x0d) continue;

		pc = strstr(buffer, "State:");
		tmpCh = *(pc - 1);
		*(pc - 1) = 0;
		strcpy(pTmp->svcName, buffer);	// get the service name
		*(pc - 1) = tmpCh;

		// get the properties
		pTmp->svcState = atol( pc+6 );

		pc = strstr(buffer, "Type:");
		pTmp->svcType = atol( pc+5 );

		pc = strstr(buffer, "PID:");
		pTmp->svcPid = atol( pc+4 );

		pc = strstr(buffer, "Flags:");
		pTmp->svcFlags = atol( pc+6 );

		pTmp++;
	}

//	printServiceNode(pTop, number);
	return(pTop);
} // readServiceFile

// get a list of the services on this machine
void enumerateLocalServices(SYSTEMTIME *sysTime)
{
	BOOL result;
	SC_HANDLE sch;
	DWORD i, pcbBytesNeeded, lpServicesReturned, lpResumeHandle;
	char logFileName[MAX_PATH];

	sprintf(logFileName, "ServiceList_%04d_%02d_%02d_%02d_%02d_%02d.log", 
		sysTime->wYear, sysTime->wMonth, sysTime->wDay, 
		sysTime->wHour, sysTime->wMinute, sysTime->wSecond);

	// open the file
	gFptr = fopen(logFileName, "w+");
	if(gFptr == NULL)
	{
		fprintf(stderr, "\n\nError! Could not open log file %s for writing.\n\n", logFileName);
		return;
	}

	fprintf(stdout, "\nEnumerating Services\n\n");
	fprintf(gFptr, "SERVICES\n\n");

	// open the service control manager, local machine, default service DB
	sch = OpenSCManager(NULL, NULL, SC_MANAGER_ENUMERATE_SERVICE  );
	if(sch == NULL)
	{
		fprintf(stderr, "\n\nError, could not open SCM database.\n\n");
		return;
	}

	// get the services in an array of structures
	pcbBytesNeeded = 0;
	lpServicesReturned = 0;
	lpResumeHandle = 0;
	result = EnumServicesStatusEx(sch, SC_ENUM_PROCESS_INFO, SERVICE_TYPE_ALL, SERVICE_STATE_ALL,
				glBuffer, 64*1024, &pcbBytesNeeded, &lpServicesReturned, &lpResumeHandle, NULL);

	if(result == FALSE)
	{
		fprintf(stderr, "\n\nError, could not Enumerate Services.\n\n");
		return;
	}

	fprintf(stdout, "NumServices:%u\n\n", lpServicesReturned);
	fprintf(gFptr, "NumServices:%u\n\n", lpServicesReturned);

	pService = (ENUM_SERVICE_STATUS_PROCESS *) glBuffer;

	for(i = 0; i < lpServicesReturned; i++)		// display name first, service name is unique
	{
		fprintf(gFptr, "%s\n%s State:%u Type:%u PID:%u Flags:%u\n\n", 
			pService->lpDisplayName, pService->lpServiceName, 
			pService->ServiceStatusProcess.dwCurrentState,
			pService->ServiceStatusProcess.dwServiceType,
			pService->ServiceStatusProcess.dwProcessId,		// zero if NOT running, non-zero otherwise
			pService->ServiceStatusProcess.dwServiceFlags); // if zero, NOT a system process

		pService++;
	}

	fclose(gFptr);
	return;
} // enumerateLocalServices
