// WriteBMP.h
//
// This file contains the bitmap template and other definitions
//

#define VERSION 5.57

#define SUCCESS 0
#define FAILURE -1

typedef struct _RGB
{
	unsigned char blu;	// same order as in bitmap palette  ff,00,00 --- yellow		00,ff,ff
	unsigned char grn;	//									00,ff,00 --- magenta	ff,00,ff
	unsigned char red;	//									00,00,ff --- cyan		ff,ff,00
} RGB;

// height of the bitmap that graphically shows the histogram
#define HISTOGRAM_HEIGHT 512

// allow WBH to work with really large files
// limits each image to 32 Mbytes
#define MAX_BMP_SIZE 32 * 1048576

#define BMP_WIDTH 516
#define BMP_HEIGHT 532
#define HIST_HEIGHT 512
#define HIST_WIDTH 512

typedef unsigned __int64 QWORD;

extern BITMAPFILEHEADER gBM_FileHeader;
extern BITMAPINFOHEADER gBM_InfoHeader;

extern QWORD gHistogram[256];
extern QWORD gTmpHistogram[256];
extern QWORD gHistogram2D[256][256];

extern DWORD ghWidth;
extern float gZoomFactor;
extern bool gPercentFlag;
extern bool gLogFlag;
extern bool gScaledFlag;
extern bool gZoomTop;

extern bool gCreateBMP;	// when true, will create BMP image of target file



/*
// this structure defines the file header format for a bitmap file
typedef struct tagBITMAPFILEHEADER // (14 bytes)
{
        WORD    bfType;					// ASCII "BM"
        DWORD   bfSize;					// total length of bitmap file
        WORD    bfReserved1;			// reserved
        WORD    bfReserved2;			// reserved
        DWORD   bfOffBits;				// offset to start of actual pixel data
} BITMAPFILEHEADER;

// this structure defines the header which describes the bitmap itself
typedef struct tagBITMAPINFOHEADER // (40 bytes)
{
        DWORD      biSize;				// size of BITMAPINFOHEADER
        LONG       biWidth;				// width in pixels
        LONG       biHeight;			// height in pixels
        WORD       biPlanes;			// always 1
        WORD       biBitCount;			// color bits per pixel
        DWORD      biCompression;		// BI_RGB, BI_RLE8, BI_RLE4
        DWORD      biSizeImage;			// total bytes in image
        LONG       biXPelsPerMeter;		// 0, or optional horizontal resolution
        LONG       biYPelsPerMeter;		// 0, or optional vertical resolution
        DWORD      biClrUsed;			// colors actually used (normally zero, can be lower than biBitCount)
        DWORD      biClrImportant;		// important colors actualy used (normally zero)
} BITMAPINFOHEADER;	

typedef struct tagRGBQUAD
{
        BYTE    rgbBlue;
        BYTE    rgbGreen;
        BYTE    rgbRed;
        BYTE    rgbReserved;
} RGBQUAD;

//*/